#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "config.h"
#include "interface.h"
#include "support.h"
#include "system.h"
#include "gzip.h"
char *gzipexe;
float gziplen=0;
void gzipCompress(char *saveas){
  errMessage=create_dlgMessage();
  txtMessage=lookup_widget(errMessage,"txtMessage");
  if(methods.gzip.Intern==1)
	internGzip(saveas);
  else
	externGzip(saveas);
}

void targzipCompress(char *saveas){
  errMessage=create_dlgMessage();
  txtMessage=lookup_widget(errMessage,"txtMessage");
  if(methods.gzip.Intern==1)
	internTarGzip(saveas);
  else
	externTarGzip(saveas);
}

void gzipParseOptions(){
  gzipexe=(char*)malloc(2048);
  memset(gzipexe,0x0,sizeof(gzipexe));
//  strcpy(gzipexe,methods.gzip.Exe);
  strcpy(gzipexe,"-");
  if(methods.gzip.Store==1)
	strcat(gzipexe,"0");
  else{
	char *temp;
	temp=(char*)malloc(sizeof(temp));
	sprintf(temp,"%d",methods.gzip.CompLevel);
	strcat(gzipexe,temp);
	free(temp);
  }
  if(methods.gzip.WriteOverOut==1)
	strcat(gzipexe,"f");
/*  if(methods.gzip.TestInt==1)
	strcat(gzipexe,"t");*/
  if(methods.gzip.RecThru==1)
	strcat(gzipexe,"r");
/*  if(methods.gzip.KeepInput==1)
	strcat(gzipexe,""); Only on Internal GZip*/
  if(methods.gzip.AltSuf==1){
	char temp[256];
	int i=0,j=0;
	memset(temp,0x0,sizeof(temp));
	strcat(gzipexe,"S");
	for(i=0;i<strlen(methods.gzip.Suffix);i++){
	    if(methods.gzip.Suffix[i]!=' ')
		temp[j++]=methods.gzip.Suffix[i];
	}
	if(temp[0]!='.'){
	    memset(methods.gzip.Suffix,0x0,sizeof(methods.gzip.Suffix));
	    strcpy(methods.gzip.Suffix,temp);
	    memset(temp,0x0,sizeof(temp));
	    temp[0]='.';
	    strcat(temp,methods.gzip.Suffix);
	    strcpy(methods.gzip.Suffix,temp);
	}
	strncat(gzipexe,temp,strlen(temp));
    }
}

void externGzip(char *saveas){
  FILE *fp;
  char *buffer,*exe[8194];
  char temp2[256];
  int status=0;
  float nums=0,size=0;
  nums=selTo->numrows;
  gdk_threads_enter();
  lstTo=lookup_widget(winMain,"lstTo");
  for(gziplen=0;;gziplen++){
	if(cancelled==1)
	  break;
	if(gtk_clist_get_text(GTK_CLIST(lstTo),gziplen,0,&buffer)==0)
  	  break;
  	else{
  	  fp=fopen(buffer,"r");
  	  fseek(fp,0L,SEEK_END);
  	  size=ftell(fp);
  	  fclose(fp);
	  gtk_progress_configure(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),0,0,size);
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/5);
  	  while(gtk_events_pending())
    	    gtk_main_iteration();
  	  gzipParseOptions();
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/4);
  	  while(gtk_events_pending())
  	    gtk_main_iteration();
  	  exe[0]=methods.gzip.Exe;
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/3);
  	  while(gtk_events_pending())
    	    gtk_main_iteration();
  	  exe[1]=gzipexe;
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/2);
  	  while(gtk_events_pending())
    	    gtk_main_iteration();
  	  exe[2]=buffer;
    	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/1);
    	  while(gtk_events_pending())
      	    gtk_main_iteration();	
	  status=mySystem(exe);
//	  printf("status %d\n",status);
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size);
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsTotalFiles")),gziplen+1);
  	  gtk_label_set_text(GTK_LABEL(lookup_widget(Progress,"lblProgressFileName")),buffer);
  	  memset(temp2,0x0,sizeof(temp2));
  	  sprintf(temp2,"%1.0f of %1.0f done",gziplen+1,nums);
  	  gtk_label_set_text(GTK_LABEL(lookup_widget(Progress,"lblProgressTotalFiles")),temp2);
  	  while(gtk_events_pending())
    	    gtk_main_iteration();
	  if(methods.gzip.TestInt==1){
	    memset(exe,0x0,sizeof(exe));
	    exe[0]=methods.gzip.Exe;
	    exe[1]="-t";
	    if(methods.gzip.AltSuf==1){
		strcat(buffer,methods.gzip.Suffix);
		exe[2]=buffer;
	    }else{
		strcat(buffer,".gz");
		exe[2]=buffer;
	    }	
	    status=mySystem(exe);
	    if(status==256){
              gtk_text_backward_delete(GTK_TEXT(txtMessage),gtk_text_get_length(GTK_TEXT(txtMessage)));
	      gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,GZERR_MSG02,strlen(GZERR_MSG02));
              gtk_widget_show(errMessage);
	    }else{
              gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size+=10);
              gtk_label_set_text(GTK_LABEL(lookup_widget(Progress,"lblProgressFileName")),"Testing the file");
    	      while(gtk_events_pending())
    	        gtk_main_iteration();	
	      gtk_text_backward_delete(GTK_TEXT(txtMessage),gtk_text_get_length(GTK_TEXT(txtMessage)));
	      gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,GZERR_MSG03,strlen(GZERR_MSG03));
	      gtk_widget_show(errMessage);
            }
          }
	}
  }
  if(cancelled==1){
//	printf("Cancelled\n");
	gtk_text_backward_delete(GTK_TEXT(txtMessage),gtk_text_get_length(GTK_TEXT(txtMessage)));
	gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ERR_MSG08,strlen(ERR_MSG08));
	gtk_widget_show(errMessage);
  }else{
    gtk_widget_hide(lookup_widget(Progress,"btnProgressCancel"));
    gtk_widget_show(lookup_widget(Progress,"btnProgressDone"));
  }
  /*else{
	gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsTotalFiles")),len+1);
	while(gtk_events_pending())
  	  gtk_main_iteration();	
	gtk_widget_hide(lookup_widget(Progress,"btnProgressCancel"));
	gtk_widget_show(lookup_widget(Progress,"btnProgressClose"));
	gtk_widget_grab_default(lookup_widget(Progress,"btnProgressClose"));*/
//  gtk_clist_remove(GTK_CLIST(lstTo),len);
	gdk_threads_leave();
  //}
}

int internGzip(char *saveas){
  return 0;
}  

void externTarGzip(char *saveas){
  FILE *fp;
  char *exe[8194];
  char temp2[256];
  int status=0;
  float nums=0,size=0;
  nums=selTo->numrows;
  gdk_threads_enter();
  lstTo=lookup_widget(winMain,"lstTo");
//  for(gziplen=0;;gziplen++){
    	if(cancelled==1)
	    goto cancel;
	else{
  	  fp=fopen(saveas,"r");
  	  fseek(fp,0L,SEEK_END);
  	  size=ftell(fp);
  	  fclose(fp);
	  gtk_progress_configure(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),0,0,size);
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/5);
  	  while(gtk_events_pending())
    	    gtk_main_iteration();
  	  gzipParseOptions();
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/4);
  	  while(gtk_events_pending())
  	    gtk_main_iteration();
  	  exe[0]=methods.gzip.Exe;
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/3);
  	  while(gtk_events_pending())
    	    gtk_main_iteration();
  	  exe[1]=gzipexe;
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/2);
  	  while(gtk_events_pending())
    	    gtk_main_iteration();
  	  exe[2]=saveas;
    	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/1);
    	  while(gtk_events_pending())
      	    gtk_main_iteration();	
	  status=mySystem(exe);
//	  printf("status %d\n",status);
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size);
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsTotalFiles")),gziplen+1);
  	  gtk_label_set_text(GTK_LABEL(lookup_widget(Progress,"lblProgressFileName")),saveas);
  	  memset(temp2,0x0,sizeof(temp2));
  	  sprintf(temp2,"%1.0f of %1.0f done",gziplen+1,nums);
  	  gtk_label_set_text(GTK_LABEL(lookup_widget(Progress,"lblProgressTotalFiles")),temp2);
  	  while(gtk_events_pending())
    	    gtk_main_iteration();
	  if(methods.gzip.TestInt==1){
	    memset(exe,0x0,sizeof(exe));
	    exe[0]=methods.gzip.Exe;
	    exe[1]="-t";
	    if(methods.gzip.AltSuf==1){
		strcat(saveas,methods.gzip.Suffix);
		exe[2]=saveas;
	    }else{
		strcat(saveas,".gz");
		exe[2]=saveas;
	    }	
	    status=mySystem(exe);
	    if(status==256){
              gtk_text_backward_delete(GTK_TEXT(txtMessage),gtk_text_get_length(GTK_TEXT(txtMessage)));
	      gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,GZERR_MSG02,strlen(GZERR_MSG02));
              gtk_widget_show(errMessage);
	    }else{
              gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size+=10);
              gtk_label_set_text(GTK_LABEL(lookup_widget(Progress,"lblProgressFileName")),"Testing the file");
    	      while(gtk_events_pending())
    	        gtk_main_iteration();	
	      gtk_text_backward_delete(GTK_TEXT(txtMessage),gtk_text_get_length(GTK_TEXT(txtMessage)));
	      gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,GZERR_MSG03,strlen(GZERR_MSG03));
	      gtk_widget_show(errMessage);
            }
          }
	}
//  }
cancel:
  if(cancelled==1){
//	printf("Cancelled\n");
	gtk_text_backward_delete(GTK_TEXT(txtMessage),gtk_text_get_length(GTK_TEXT(txtMessage)));
	gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ERR_MSG08,strlen(ERR_MSG08));
	gtk_widget_show(errMessage);
  }else{
    gtk_widget_hide(lookup_widget(Progress,"btnProgressCancel"));
    gtk_widget_show(lookup_widget(Progress,"btnProgressDone"));
  }
  /*else{
	gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsTotalFiles")),len+1);
	while(gtk_events_pending())
  	  gtk_main_iteration();	
	gtk_widget_hide(lookup_widget(Progress,"btnProgressCancel"));
	gtk_widget_show(lookup_widget(Progress,"btnProgressClose"));
	gtk_widget_grab_default(lookup_widget(Progress,"btnProgressClose"));*/
//  gtk_clist_remove(GTK_CLIST(lstTo),len);
	gdk_threads_leave();
  //}
}

int internTarGzip(char *saveas){
  return 0;
}  
